///////////////////////////////////////////////////////////////////////////////
// SectionHandler.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ExtendedFileWrapper.h"
#include "FileContents.h"

class VSectionHandler
{
protected:
	VExtendedFileWrapper & m_rFile;
public:
	enum EParseResult	{ ENoError = 0, EReadError, EOutOfMemory };
	
	
	VSectionHandler(VExtendedFileWrapper & a_rFileWrapper);
	virtual ~VSectionHandler() = 0;

	virtual bool CanHandle(std::string a_strSectionName) = 0;

	virtual EParseResult ReadSection(VFileContents & a_rContents, SLONG a_SectionLength) = 0;
	virtual void WriteSection(VFileSection * a_pSection) = 0;
	virtual bool WriteSectionHeader(SLONG a_SectionLen, std::string a_strName) = 0;
	virtual bool RewriteSection(VFileSection * a_pSection) = 0;
};

