///////////////////////////////////////////////////////////////////////////////
// ThinFileWrapper.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <fstream>
#include <string>

class VThinFileWrapper
{
private:
	FILE * m_pFileHandle;

public:
	VThinFileWrapper();
	virtual ~VThinFileWrapper();

	bool OpenFile(std::string a_strFilename, std::string a_strMode);
	bool CreateFile(std::string a_strFilename);
	void CloseFile();

	bool IsOpen() { return m_pFileHandle != NULL; }
	bool eof() { return feof(m_pFileHandle) != 0; }

	bool Read(void * a_pBuffer, int a_Size);
	bool Seek(int a_NumBytesToSkip, int a_Origin);
	bool Write(const void * a_pBuffer, int a_Size);

	bool Flush() { return fflush(m_pFileHandle) == 0; }
};

