#pragma once

#define CREATE_OFFSET_CUBES	"CreateOffsetCubes"

#include <maya/MPxCommand.h>
#include <maya/MSyntax.h>

#include <string>

#define CUBE_DIM_IN_CM 5.0

class VCreateOffsetCubes : public MPxCommand  
{
public:
	void DisplayError(MString & title, MString & explanation);

	VCreateOffsetCubes();
	virtual ~VCreateOffsetCubes() {}

	MStatus  doIt( const MArgList& args );
	MStatus  redoIt();
	
	static void *	creator(); 

	bool	isUndoable() const;
	bool	hasSyntax() const;

private:
	void CreateCubesForChildren(std::string a_strObjectName);
	bool IsDofLocatorName(std::string a_strObjectName);
	void CreateCube(std::string a_strCubeName, std::string a_strLocatorName);
	void DeletePeskyConstraints(std::string a_strObjectName);
	float m_CubeDim;
};
