// VDOFLocator.h: interface for the VDOFLocator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOFLocator_H__)
#define AFX_DOFLocator_H__

#include <maya/MPxLocatorNode.h> 
#include <maya/MString.h> 
#include <maya/MTypeId.h> 
#include <maya/MVector.h>
#include <maya/MDataBlock.h>
#include <maya/MDataHandle.h>
#include <maya/MColor.h>
#include <maya/M3dView.h>
#include <maya/MDistance.h>
#include <maya/MFnUnitAttribute.h>

#define DOF_LOCATOR		"DOFLocator"
#define MARKER_LOCATOR	"MarkerLocator"

static float abcd[][3] =
{
	{ -0.5f,  0.5f, 0.5f }, { 0.5f,  0.5f, 0.5f  },
	{ 0.5f, 0.5f, -0.5f  }, { -0.5f, 0.5f, -0.5f }
};

static float ABCD[][3] =
{
	{ -0.5f, -0.5f, 0.5f }, { 0.5f, -0.5f, 0.5f  },
	{ 0.5f, -0.5f, -0.5f  }, { -0.5f, -0.5f, -0.5f }
};

static float CDAB[][3] =
{
	{ 0.5f, -0.5f, -0.5f }, { -0.5f, -0.5f, -0.5f },
	{ -0.5f, -0.5f, 0.5f }, { 0.5f, -0.5f, 0.5f  }
};

static int vertexCount = 4;

class VDOFLocator : public MPxLocatorNode
{
public:
	VDOFLocator()			{}
	virtual ~VDOFLocator()	{}

    virtual MStatus   		compute( const MPlug& plug, MDataBlock& data );

	virtual void            draw( M3dView & view, const MDagPath & path, 
								  M3dView::DisplayStyle style,
								  M3dView::DisplayStatus status );

	virtual bool            isBounded() const;
	virtual MBoundingBox    boundingBox() const; 

	static  void *          creator();
	static  MStatus         initialize();

	static  MObject         size;         // The size of the foot

public: 
	static	MTypeId		id;
};

class VMarkerLocator : public VDOFLocator
{
public:
	VMarkerLocator()			{}
	virtual ~VMarkerLocator()	{}

	static void * creator();
	virtual void draw(M3dView & view, const MDagPath & path, M3dView::DisplayStyle style, M3dView::DisplayStatus status);

	static  MObject     size;         // The size of the foot
	static	MTypeId		id;
};

#endif

